﻿ using System;
using System.Collections.Generic;
using UnityEngine;

namespace CarMod
{
    public class CarMod : MonoBehaviour
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Tank"),
                    NameOverride = "M2 Bradley Sand",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "M2 Bradley in Sand coloring",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/sand/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.CreateParticleEffect("IonExplosion", Instance.transform.position).transform.localScale = new Vector3(5f, 5f); ;
                        Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
                        var TankHead = Instance.transform.Find("Head");
                        var TankBody = Instance.transform.Find("Body");
                        var TankBarrel = Instance.transform.Find("Barrel");
                        var TankGasTank = Instance.transform.Find("Gas tank");
                        var TankEngine = Instance.transform.Find("Engine");
                        var TankSettings = TankBody.GetComponent<CarBehaviour>();
                        TankSettings.MotorSpeed = -500f;
                        TankSettings.WaterProof = false;
                        DestroyManager tank = Instance.AddComponent<DestroyManager>();
                        tank.objects = new GameObject[11];


                        TankHead.localPosition = new Vector3(-0.2f, 1.68f);
                        TankGasTank.localPosition = new Vector3(-2.95f, 0f);
                        TankEngine.localPosition = new Vector3(-3.2f, 0.2f);
                        TankGasTank.transform.localScale = new Vector3(0.7f, 0.7f);

                        TankBarrel.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                        ModAPI.LoadSprite(""),
                        };

                        //Tank Head
                        TankBarrel.transform.localScale = new Vector3(1f, 1f, 1f);

                        TankHead.transform.localScale = new Vector3(1.1f, 1.1f);
                        TankHead.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                            ModAPI.LoadSprite("Textures/sand/tank tower.png"),
                            };
                        TankHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/tank towerRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        TankHead.gameObject.FixColliders();
                        TankHead.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        PolygonCollider2D TankHeadColl = TankHead.GetComponent<PolygonCollider2D>();
                        TankHeadColl.pathCount = 1;
                        TankHeadColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(1.6314857f,0.184812218f),
                        new Vector2(1.52837765f,0.278122693f),
                        new Vector2(0.441590995f,0.410492361f),
                        new Vector2(0.431270599f,0.553485155f),
                        new Vector2(-0.43660453f,0.55257839f),
                        new Vector2(-0.578489304f,0.379149199f),
                        new Vector2(-0.757416606f,0.37690264f),
                        new Vector2(-0.853400052f,0.263757586f),
                        new Vector2(-2.61639595f,0.265810847f),
                        new Vector2(-2.61716962f,0.318027824f),
                        new Vector2(-2.77894449f,0.319069624f),
                        new Vector2(-2.98050332f,0.0641085505f),
                        new Vector2(-3.14709687f,0.0608592033f),
                        new Vector2(-3.23824358f,-0.134591088f),
                        new Vector2(-3.46509767f,-0.137840196f),
                        new Vector2(-3.46211982f,-0.364678144f),
                        new Vector2(-2.99959159f,-0.465325445f),
                        new Vector2(-2.61677456f,-0.461370319f),
                        new Vector2(-2.53225327f,-0.407977879f),
                        new Vector2(-2.28820467f,-0.660381675f),
                        new Vector2(-1.57422578f,-0.835526586f),
                        new Vector2(3.08029175f,-0.825316548f),
                        new Vector2(3.30741239f,-0.471253693f),
                        new Vector2(3.29403281f,-0.426766813f),
                        new Vector2(2.94575667f,0.0781132281f)
                    });
                        //Body	
                        TankBody.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                             {
                            ModAPI.LoadSprite("Textures/sand/body.png"),
                             };
                        TankBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BodyRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        TankBody.gameObject.FixColliders();
                        TankBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        TankBody.transform.localScale = new Vector3(1.1f, 1.1f);

                        GameObject.Destroy(Instance.transform.GetChild(11).gameObject);
                        Instance.transform.GetChild(0).GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Background.png");
                        //Gas Tank
                        Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                        ModAPI.LoadSprite("Textures/Gastank.png"),
                        };
                        //Engine
                        Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                        ModAPI.LoadSprite("Textures/Engine.png"),
                        };
                        //Wheels
                        Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/sand/Wheel1.png"),
                                };
                        Instance.transform.Find("Wheel").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                               {
                                    ModAPI.LoadSprite(""),
                                };
                        Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (2)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (3)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (4)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (5)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (6)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                                    ModAPI.LoadSprite("Textures/sand/Wheel0.png"),
                    };
                        Instance.transform.Find("Wheel (7)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                                    ModAPI.LoadSprite("Textures/sand/Wheel1.png"),
                    };
                        Instance.transform.Find("Wheel (8)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[8].anchor = new Vector2(-2.9f, -0.8f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[6].anchor = new Vector2(-2f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[5].anchor = new Vector2(-1.2f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[4].anchor = new Vector2(-0.4f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[3].anchor = new Vector2(0.6f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[2].anchor = new Vector2(1.4f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[1].anchor = new Vector2(2.2f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[0].anchor = new Vector2(3.1f, -0.8f);
                        //Other

                        Instance.AddComponent<NoChildrenCollide>();
                        NoCollide noCollide = Instance.AddComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();


                        SliderJoint2D door3 = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Cube").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<SliderJoint2D>();
                        door3.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/sand/door3.png");
                        door3.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Top");
                        door3.transform.localScale = new Vector3(1.1f * Instance.transform.lossyScale.x, 1.1f);
                        door3.gameObject.FixColliders();
                        door3.gameObject.layer = 10;
                        door3.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        door3.autoConfigureAngle = false;
                        door3.angle = Instance.transform.lossyScale.x < 0 ? -90f : 270f;
                        door3.anchor = new Vector2(3.52f, -0.1f);
                        JointTranslationLimits2D doorLimits3 = new JointTranslationLimits2D();
                        doorLimits3.min = 0f;
                        doorLimits3.max = 1f;
                        door3.limits = doorLimits3;
                        JointMotor2D doorMotor3 = new JointMotor2D();
                        doorMotor3.motorSpeed = -100f;
                        doorMotor3.maxMotorTorque = 100f;
                        door3.motor = doorMotor3;
                        door3.gameObject.AddComponent<UseEventTrigger>().Action = () => { doorMotor3.motorSpeed *= -1f; door3.motor = doorMotor3; };

                        SliderJoint2D door = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Cube").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<SliderJoint2D>();
                        door.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/sand/door.png");
                        door.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Top");
                        door.transform.localScale = new Vector3(1.1f * Instance.transform.lossyScale.x, 1.1f);
                        door.gameObject.FixColliders();
                        door.gameObject.layer = 10;
                        door.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        door.autoConfigureAngle = false;
                        door.angle = Instance.transform.lossyScale.x < 0 ? -90f : 270f;
                        door.anchor = new Vector2(0f, 0.15f);
                        JointTranslationLimits2D doorLimits = new JointTranslationLimits2D();
                        doorLimits.min = 0f;
                        doorLimits.max = 1.55f;
                        door.limits = doorLimits;
                        JointMotor2D doorMotor = new JointMotor2D();
                        doorMotor.motorSpeed = -100f;
                        doorMotor.maxMotorTorque = 100f;
                        door.motor = doorMotor;
                        door.gameObject.AddComponent<UseEventTrigger>().Action = () => { doorMotor.motorSpeed *= -1f; door.motor = doorMotor; };


                        SliderJoint2D door2 = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Cube").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<SliderJoint2D>();
                        door2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/sand/door2.png");
                        door2.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Top");
                        door2.transform.localScale = new Vector3(1.1f * Instance.transform.lossyScale.x, 1.1f);
                        door2.gameObject.FixColliders();
                        door2.gameObject.layer = 10;
                        door2.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        door2.autoConfigureAngle = false;
                        door2.angle = Instance.transform.lossyScale.x < 0 ? -90f : 270f;
                        door2.anchor = new Vector2(-2.15f, -0.145f);
                        JointTranslationLimits2D doorLimits2 = new JointTranslationLimits2D();
                        doorLimits2.min = 0f;
                        doorLimits2.max = 1f;
                        door2.limits = doorLimits2;
                        JointMotor2D doorMotor2 = new JointMotor2D();
                        doorMotor2.motorSpeed = -100f;
                        doorMotor2.maxMotorTorque = 100f;
                        door2.motor = doorMotor2;
                        door2.gameObject.AddComponent<UseEventTrigger>().Action = () => { doorMotor2.motorSpeed *= -1f; door2.motor = doorMotor2; };

                        HingeJoint2D light = GameObject.Instantiate(ModAPI.FindSpawnable("Lightbulb").Prefab, TankBody.transform.position + new Vector3(3.95f * Instance.transform.lossyScale.x, 0.28f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                        light.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        light.GetComponent<SpriteRenderer>().sprite = null;
                        light.anchor = new Vector2(0f, 0f);
                        light.transform.eulerAngles = new Vector3(0f, 0f, 90f * Instance.transform.lossyScale.x);
                        light.transform.parent = TankBody.transform;
                        light.transform.localScale = new Vector3(0.4f, 0.4f);

                        JointAngleLimits2D lim = new JointAngleLimits2D();
                        lim.min = 0f;
                        lim.max = 0f;
                        light.limits = lim;


                        if (Instance.transform.lossyScale.x < 0)
                        {
                            HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(3.5f, 0f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                            smoke.GetComponent<SpriteRenderer>().sprite = null;
                            smoke.transform.parent = TankBody.transform;
                            tank.objects[10] = smoke.gameObject;
                        }
                        else
                        {

                            HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(-3.5f, 0f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                            smoke.GetComponent<SpriteRenderer>().sprite = null;
                            smoke.transform.parent = TankBody.transform;
                            tank.objects[10] = smoke.gameObject;
                        }


                        HingeJoint2D gun = GameObject.Instantiate(ModAPI.FindSpawnable("Detached 30mm HEAT Cannon").Prefab, Instance.transform.position + new Vector3(1.8f * Instance.transform.lossyScale.x, 1.2f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                        gun.GetComponent<Rigidbody2D>().angularDrag = 1000000f;
                        gun.GetComponent<Rigidbody2D>().gravityScale = 0f;
                        gun.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/sand/Barrel.png");
                        gun.transform.localScale = new Vector3(Instance.transform.lossyScale.x * 1.1f, 1.1f);
                        gun.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                        gun.anchor = new Vector2(-1f, 0f);

                        JointAngleLimits2D jal = new JointAngleLimits2D();
                        jal.min = Instance.transform.lossyScale.x < 0 ? -10 : -50f;
                        jal.max = Instance.transform.lossyScale.x < 0 ? 50 : 10f;
                        gun.limits = jal;

                        if (Instance.transform.lossyScale.x < 0)
                        {
                            GameObject grenade = GameObject.Instantiate(ModAPI.FindSpawnable("Rocket Launcher").Prefab, TankHead.transform.position + new Vector3(1.6f, 0.7f, 0f), Quaternion.identity);
                            grenade.transform.localScale = new Vector3(-1.1f, 1.1f);
                            grenade.transform.parent = TankHead.transform;
                            grenade.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                            grenade.GetComponent<Rigidbody2D>().gravityScale = 0f;
                            grenade.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                            ModAPI.LoadSprite("Textures/sand/gun.png"),
                            };
                            grenade.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gunRed.png", 10);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            grenade.gameObject.FixColliders();
                            grenade.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 0;

                            HingeJoint2D hj2 = grenade.AddComponent<HingeJoint2D>();
                            hj2.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                            hj2.anchor = new Vector2(0f, 0f);
                            JointAngleLimits2D limits2 = new JointAngleLimits2D();
                            limits2.min = 10f;
                            limits2.max = -10f;
                            hj2.limits = limits2;
                            tank.objects[5] = grenade.gameObject;
                        }
                        else
                        {
                            GameObject grenade = GameObject.Instantiate(ModAPI.FindSpawnable("Rocket Launcher").Prefab, TankHead.transform.position + new Vector3(-1.6f, 0.7f, 0f), Quaternion.identity);
                            grenade.transform.localScale = new Vector3(1.1f, 1.1f);
                            grenade.transform.parent = TankHead.transform;
                            grenade.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                            grenade.GetComponent<Rigidbody2D>().gravityScale = 0f;
                            grenade.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                            ModAPI.LoadSprite("Textures/sand/gun.png"),
                            };
                            grenade.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gunRed.png", 10);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            grenade.gameObject.FixColliders();
                            grenade.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 0;

                            HingeJoint2D hj2 = grenade.AddComponent<HingeJoint2D>();
                            hj2.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                            hj2.anchor = new Vector2(0f, 0f);
                            JointAngleLimits2D limits2 = new JointAngleLimits2D();
                            limits2.min = 10f;
                            limits2.max = -10f;
                            hj2.limits = limits2;
                            tank.objects[5] = grenade.gameObject;
                        }

                        tank.objects[0] = TankBody.gameObject;
                        tank.objects[1] = TankHead.gameObject;
                        tank.objects[2] = TankGasTank.gameObject;
                        tank.objects[3] = TankEngine.gameObject;
                        tank.objects[4] = TankBarrel.gameObject;
                        tank.objects[6] = gun.gameObject;
                        tank.objects[7] = door.gameObject;
                        tank.objects[8] = door2.gameObject;
                        tank.objects[9] = door3.gameObject;




                        GameObject.Destroy(TankBarrel.transform.GetChild(11).gameObject);
                        GameObject.Destroy(Instance.transform.Find("Wheel (1)").gameObject);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Tank"),
                    NameOverride = "M2 Bradley Green",
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "M2 Bradley in Khaki coloring",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/green/Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        ModAPI.CreateParticleEffect("IonExplosion", Instance.transform.position).transform.localScale = new Vector3(5f, 5f); ;
                        Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
                        var TankHead = Instance.transform.Find("Head");
                        var TankBody = Instance.transform.Find("Body");
                        var TankBarrel = Instance.transform.Find("Barrel");
                        var TankGasTank = Instance.transform.Find("Gas tank");
                        var TankEngine = Instance.transform.Find("Engine");
                        var TankSettings = TankBody.GetComponent<CarBehaviour>();
                        TankSettings.MotorSpeed = -500f;
                        TankSettings.WaterProof = false;
                        DestroyManager tank = Instance.AddComponent<DestroyManager>();
                        tank.objects = new GameObject[11];


                        TankHead.localPosition = new Vector3(-0.2f, 1.68f);
                        TankGasTank.localPosition = new Vector3(-2.95f, 0f);
                        TankEngine.localPosition = new Vector3(-3.2f, 0.2f);
                        TankGasTank.transform.localScale = new Vector3(0.7f, 0.7f);

                        TankBarrel.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                        ModAPI.LoadSprite(""),
                        };

                        //Tank Head
                        TankBarrel.transform.localScale = new Vector3(1f, 1f, 1f);

                        TankHead.transform.localScale = new Vector3(1.1f, 1.1f);
                        TankHead.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                            ModAPI.LoadSprite("Textures/green/tank tower.png"),
                            };
                        TankHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/tank towerRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        TankHead.gameObject.FixColliders();
                        TankHead.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        PolygonCollider2D TankHeadColl = TankHead.GetComponent<PolygonCollider2D>();
                        TankHeadColl.pathCount = 1;
                        TankHeadColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(1.6314857f,0.184812218f),
                        new Vector2(1.52837765f,0.278122693f),
                        new Vector2(0.441590995f,0.410492361f),
                        new Vector2(0.431270599f,0.553485155f),
                        new Vector2(-0.43660453f,0.55257839f),
                        new Vector2(-0.578489304f,0.379149199f),
                        new Vector2(-0.757416606f,0.37690264f),
                        new Vector2(-0.853400052f,0.263757586f),
                        new Vector2(-2.61639595f,0.265810847f),
                        new Vector2(-2.61716962f,0.318027824f),
                        new Vector2(-2.77894449f,0.319069624f),
                        new Vector2(-2.98050332f,0.0641085505f),
                        new Vector2(-3.14709687f,0.0608592033f),
                        new Vector2(-3.23824358f,-0.134591088f),
                        new Vector2(-3.46509767f,-0.137840196f),
                        new Vector2(-3.46211982f,-0.364678144f),
                        new Vector2(-2.99959159f,-0.465325445f),
                        new Vector2(-2.61677456f,-0.461370319f),
                        new Vector2(-2.53225327f,-0.407977879f),
                        new Vector2(-2.28820467f,-0.660381675f),
                        new Vector2(-1.57422578f,-0.835526586f),
                        new Vector2(3.08029175f,-0.825316548f),
                        new Vector2(3.30741239f,-0.471253693f),
                        new Vector2(3.29403281f,-0.426766813f),
                        new Vector2(2.94575667f,0.0781132281f)
                    });
                        //Body	
                        TankBody.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                             {
                            ModAPI.LoadSprite("Textures/green/body.png"),
                             };
                        TankBody.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BodyRed.png", 10);
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        TankBody.gameObject.FixColliders();
                        TankBody.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 1;
                        TankBody.transform.localScale = new Vector3(1.1f, 1.1f);

                        GameObject.Destroy(Instance.transform.GetChild(11).gameObject);
                        Instance.transform.GetChild(0).GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Background.png");
                        //Gas Tank
                        Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                        ModAPI.LoadSprite("Textures/Gastank.png"),
                        };
                        //Engine
                        Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                        ModAPI.LoadSprite("Textures/Engine.png"),
                        };
                        //Wheels
                        Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/green/Wheel1.png"),
                                };
                        Instance.transform.Find("Wheel").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                               {
                                    ModAPI.LoadSprite(""),
                                };
                        Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (2)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (3)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (4)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (5)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                            };
                        Instance.transform.Find("Wheel (6)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                                    ModAPI.LoadSprite("Textures/green/Wheel0.png"),
                    };
                        Instance.transform.Find("Wheel (7)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                                    ModAPI.LoadSprite("Textures/green/Wheel1.png"),
                    };
                        Instance.transform.Find("Wheel (8)").transform.localScale = new Vector3(1f, 1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[8].anchor = new Vector2(-2.9f, -0.8f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[6].anchor = new Vector2(-2f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[5].anchor = new Vector2(-1.2f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[4].anchor = new Vector2(-0.4f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[3].anchor = new Vector2(0.6f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[2].anchor = new Vector2(1.4f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[1].anchor = new Vector2(2.2f, -1.1f);
                        Instance.transform.GetChild(0).GetComponent<CarBehaviour>().WheelJoints[0].anchor = new Vector2(3.1f, -0.8f);
                        //Other

                        Instance.AddComponent<NoChildrenCollide>();
                        NoCollide noCollide = Instance.AddComponent<NoCollide>();
                        noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                        noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();


                        SliderJoint2D door3 = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Cube").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<SliderJoint2D>();
                        door3.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/green/door3.png");
                        door3.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Top");
                        door3.transform.localScale = new Vector3(1.1f * Instance.transform.lossyScale.x, 1.1f);
                        door3.gameObject.FixColliders();
                        door3.gameObject.layer = 10;
                        door3.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        door3.autoConfigureAngle = false;
                        door3.angle = Instance.transform.lossyScale.x < 0 ? -90f : 270f;
                        door3.anchor = new Vector2(3.52f, -0.1f);
                        JointTranslationLimits2D doorLimits3 = new JointTranslationLimits2D();
                        doorLimits3.min = 0f;
                        doorLimits3.max = 1f;
                        door3.limits = doorLimits3;
                        JointMotor2D doorMotor3 = new JointMotor2D();
                        doorMotor3.motorSpeed = -100f;
                        doorMotor3.maxMotorTorque = 100f;
                        door3.motor = doorMotor3;
                        door3.gameObject.AddComponent<UseEventTrigger>().Action = () => { doorMotor3.motorSpeed *= -1f; door3.motor = doorMotor3; };

                        SliderJoint2D door = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Cube").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<SliderJoint2D>();
                        door.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/green/door.png");
                        door.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Top");
                        door.transform.localScale = new Vector3(1.1f * Instance.transform.lossyScale.x, 1.1f);
                        door.gameObject.FixColliders();
                        door.gameObject.layer = 10;
                        door.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        door.autoConfigureAngle = false;
                        door.angle = Instance.transform.lossyScale.x < 0 ? -90f : 270f;
                        door.anchor = new Vector2(0f, 0.15f);
                        JointTranslationLimits2D doorLimits = new JointTranslationLimits2D();
                        doorLimits.min = 0f;
                        doorLimits.max = 1.55f;
                        door.limits = doorLimits;
                        JointMotor2D doorMotor = new JointMotor2D();
                        doorMotor.motorSpeed = -100f;
                        doorMotor.maxMotorTorque = 100f;
                        door.motor = doorMotor;
                        door.gameObject.AddComponent<UseEventTrigger>().Action = () => { doorMotor.motorSpeed *= -1f; door.motor = doorMotor; };


                        SliderJoint2D door2 = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Cube").Prefab, Instance.transform.position, Quaternion.identity).AddComponent<SliderJoint2D>();
                        door2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/green/door2.png");
                        door2.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Top");
                        door2.transform.localScale = new Vector3(1.1f * Instance.transform.lossyScale.x, 1.1f);
                        door2.gameObject.FixColliders();
                        door2.gameObject.layer = 10;
                        door2.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        door2.autoConfigureAngle = false;
                        door2.angle = Instance.transform.lossyScale.x < 0 ? -90f : 270f;
                        door2.anchor = new Vector2(-2.15f, -0.125f);
                        JointTranslationLimits2D doorLimits2 = new JointTranslationLimits2D();
                        doorLimits2.min = 0f;
                        doorLimits2.max = 1f;
                        door2.limits = doorLimits2;
                        JointMotor2D doorMotor2 = new JointMotor2D();
                        doorMotor2.motorSpeed = -100f;
                        doorMotor2.maxMotorTorque = 100f;
                        door2.motor = doorMotor2;
                        door2.gameObject.AddComponent<UseEventTrigger>().Action = () => { doorMotor2.motorSpeed *= -1f; door2.motor = doorMotor2; };

                        HingeJoint2D light = GameObject.Instantiate(ModAPI.FindSpawnable("Lightbulb").Prefab, TankBody.transform.position + new Vector3(3.9f * Instance.transform.lossyScale.x, 0.28f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                        light.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                        light.GetComponent<SpriteRenderer>().sprite = null;
                        light.anchor = new Vector2(0f, 0f);
                        light.transform.eulerAngles = new Vector3(0f, 0f, 90f * Instance.transform.lossyScale.x);
                        light.transform.parent = TankBody.transform;
                        light.transform.localScale = new Vector3(0.4f, 0.4f);

                        JointAngleLimits2D lim = new JointAngleLimits2D();
                        lim.min = 0f;
                        lim.max = 0f;
                        light.limits = lim;


                        if (Instance.transform.lossyScale.x < 0)
                        {
                            HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(3.5f, 0f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                            smoke.GetComponent<SpriteRenderer>().sprite = null;
                            smoke.transform.parent = TankBody.transform;
                            tank.objects[10] = smoke.gameObject;
                        }
                        else
                        {

                            HingeJoint2D smoke = GameObject.Instantiate(ModAPI.FindSpawnable("Particle Projector").Prefab, TankBody.transform.position + new Vector3(-3.5f, 0f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                            smoke.connectedBody = TankBody.GetComponent<Rigidbody2D>();
                            smoke.GetComponent<SpriteRenderer>().sprite = null;
                            smoke.transform.parent = TankBody.transform;
                            tank.objects[10] = smoke.gameObject;
                        }


                        HingeJoint2D gun = GameObject.Instantiate(ModAPI.FindSpawnable("Detached 30mm HEAT Cannon").Prefab, Instance.transform.position + new Vector3(1.8f * Instance.transform.lossyScale.x, 1.2f, 0f), Quaternion.identity).AddComponent<HingeJoint2D>();
                        gun.GetComponent<Rigidbody2D>().angularDrag = 1000000f;
                        gun.GetComponent<Rigidbody2D>().gravityScale = 0f;
                        gun.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/green/Barrel.png");
                        gun.transform.localScale = new Vector3(Instance.transform.lossyScale.x * 1.1f, 1.1f);
                        gun.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                        gun.anchor = new Vector2(-1f, 0f);

                        JointAngleLimits2D jal = new JointAngleLimits2D();
                        jal.min = Instance.transform.lossyScale.x < 0 ? -10 : -50f;
                        jal.max = Instance.transform.lossyScale.x < 0 ? 50 : 10f;
                        gun.limits = jal;

                        if (Instance.transform.lossyScale.x < 0)
                        {
                            GameObject grenade = GameObject.Instantiate(ModAPI.FindSpawnable("Rocket Launcher").Prefab, TankHead.transform.position + new Vector3(1.6f, 0.7f, 0f), Quaternion.identity);
                            grenade.transform.localScale = new Vector3(-1.1f, 1.1f);
                            grenade.transform.parent = TankHead.transform;
                            grenade.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                            grenade.GetComponent<Rigidbody2D>().gravityScale = 0f;
                            grenade.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                            ModAPI.LoadSprite("Textures/green/gun.png"),
                            };
                            grenade.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gunRed.png", 10);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            grenade.gameObject.FixColliders();
                            grenade.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 0;

                            HingeJoint2D hj2 = grenade.AddComponent<HingeJoint2D>();
                            hj2.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                            hj2.anchor = new Vector2(0f, 0f);
                            JointAngleLimits2D limits2 = new JointAngleLimits2D();
                            limits2.min = 10f;
                            limits2.max = -10f;
                            hj2.limits = limits2;
                            tank.objects[5] = grenade.gameObject;
                        }
                        else
                        {
                            GameObject grenade = GameObject.Instantiate(ModAPI.FindSpawnable("Rocket Launcher").Prefab, TankHead.transform.position + new Vector3(-1.6f, 0.7f, 0f), Quaternion.identity);
                            grenade.transform.localScale = new Vector3(1.1f, 1.1f);
                            grenade.transform.parent = TankHead.transform;
                            grenade.GetComponent<Rigidbody2D>().angularDrag = 10000f;
                            grenade.GetComponent<Rigidbody2D>().gravityScale = 0f;
                            grenade.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                            {
                            ModAPI.LoadSprite("Textures/green/gun.png"),
                            };
                            grenade.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/gunRed.png", 10);
                            foreach (var c in Instance.GetComponents<Collider2D>())
                            {
                                GameObject.Destroy(c);
                            }
                            grenade.gameObject.FixColliders();
                            grenade.gameObject.GetComponent<SpriteRenderer>().sortingOrder = 0;

                            HingeJoint2D hj2 = grenade.AddComponent<HingeJoint2D>();
                            hj2.connectedBody = TankHead.GetComponent<Rigidbody2D>();
                            hj2.anchor = new Vector2(0f, 0f);
                            JointAngleLimits2D limits2 = new JointAngleLimits2D();
                            limits2.min = 10f;
                            limits2.max = -10f;
                            hj2.limits = limits2;
                            tank.objects[5] = grenade.gameObject;
                        }

                        tank.objects[0] = TankBody.gameObject;
                        tank.objects[1] = TankHead.gameObject;
                        tank.objects[2] = TankGasTank.gameObject;
                        tank.objects[3] = TankEngine.gameObject;
                        tank.objects[4] = TankBarrel.gameObject;
                        tank.objects[6] = gun.gameObject;
                        tank.objects[7] = door.gameObject;
                        tank.objects[8] = door2.gameObject;
                        tank.objects[9] = door3.gameObject;




                        GameObject.Destroy(TankBarrel.transform.GetChild(11).gameObject);
                        GameObject.Destroy(Instance.transform.Find("Wheel (1)").gameObject);
                    }
                }
            );
        }
    }
    public class DestroyManager : MonoBehaviour
    {
        public GameObject[] objects;

        void OnDestroy()
        {
            foreach (GameObject o in objects)
            {
                GameObject.Destroy(o);
            }
        }
    }
}


// Originally uploaded by 'QVILL and Papaya'. Do not reupload without their explicit permission.
